Imports System.ComponentModel

<DefaultProperty("Value")> Public Class MyTrackBar
    Inherits Windows.Forms.Control

    'TODO:  
    'Private LargeChange As Integer

#Region "Public declarations"

    Public Enum enumThumbMode
        Standart = 1
        Picture = 2
        Custom = 3
    End Enum
    Public Event ValueChanged(ByVal sender As Object, ByVal e As System.EventArgs)

    Public Enum enumOrientation
        Horisontal = 1
        Vertical = 2
    End Enum

#End Region

#Region "Private declarations"
    Private mOrientation As Integer = 1
    Private mThumbWidth As Integer = 20
    Private mThumbHeight As Integer = 20
    Private mThumbColor As Color = Color.Blue
    Private mThumbBrush As New SolidBrush(Color.Blue)
    Private mThumbMode As enumThumbMode = enumThumbMode.Custom
    Private mThumbImage As Image
    Private nThumbImage As Image
    Private EnThumbImage As Image
    Private image As Image

    Private mVal As Integer
    Private mMin As Integer = 0
    Private mMax As Integer = 10

    Private XStart, XEnd, W As Integer
    Private mStep As Single
    Private mPosition As Integer
    Private mTicksRect As Rectangle
    Private mTicksRect1 As Rectangle
    Private mTrackRect As Rectangle
    Private mTrackRect1 As Rectangle
    Private mThumbRect As Rectangle
    Private mBodyRect As Rectangle
    Private G As Graphics
    Private Br As Brush = Brushes.Transparent
    Private mThumbState As VisualStyles.TrackBarThumbState = VisualStyles.TrackBarThumbState.Normal
#End Region

    Public Sub New()
        Me.SetStyle(ControlStyles.UserPaint, True)
        Me.SetStyle(ControlStyles.OptimizedDoubleBuffer, True)
        'Me.SetStyle(ControlStyles.Opaque, True)
    End Sub

    Protected Overrides Sub OnPaint(ByVal e As System.Windows.Forms.PaintEventArgs)
        G = e.Graphics

        G.FillRectangle(Br, mBodyRect)
        'mTrackRect.Height = 5
        Select Case mOrientation
            Case enumOrientation.Horisontal
                '  ,    
                TrackBarRenderer.DrawHorizontalTrack(G, mTrackRect)
                ' 
                TrackBarRenderer.DrawHorizontalTicks(G, mTicksRect, mMax - mMin + 1, VisualStyles.EdgeStyle.Sunken)
                ' 
                mThumbRect.X = (mVal - mMin) * mStep
            Case enumOrientation.Vertical
                '  ,    
                TrackBarRenderer.DrawVerticalTrack(G, mTrackRect)

                ' 
                TrackBarRenderer.DrawVerticalTicks(G, mTicksRect, mMax - mMin + 1, VisualStyles.EdgeStyle.Sunken)

                ' 
                mThumbRect.Y = (mVal - mMin) * mStep

        End Select



        Select Case mThumbMode
            Case enumThumbMode.Custom
                G.SmoothingMode = Drawing2D.SmoothingMode.AntiAlias
                G.FillEllipse(mThumbBrush, mThumbRect)
                G.SmoothingMode = Drawing2D.SmoothingMode.Default

            Case enumThumbMode.Standart
                TrackBarRenderer.DrawTopPointingThumb(G, mThumbRect, mThumbState)

            Case enumThumbMode.Picture
                If Me.Enabled = False Then
                    G.DrawImage(EnThumbImage, mThumbRect)
                Else
                    G.SmoothingMode = Drawing2D.SmoothingMode.AntiAlias
                    G.DrawImage(mThumbImage, mThumbRect)
                    G.SmoothingMode = Drawing2D.SmoothingMode.Default
                End If
        End Select

        '

    End Sub

#Region "MouseDown, MouseUp, MouseWheel, MouseMove"

    Private Sub MyTrackBar_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseDown
        If mThumbRect.Contains(e.X, e.Y) Then
            mThumbState = VisualStyles.TrackBarThumbState.Pressed
            image = mThumbImage
            mThumbImage = nThumbImage
            Me.Invalidate(mThumbRect)
        End If
    End Sub

    Private Sub MyTrackBar_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseUp
        If mThumbRect.Contains(e.X, e.Y) Then
            mThumbState = VisualStyles.TrackBarThumbState.Hot
        Else
            mThumbState = VisualStyles.TrackBarThumbState.Normal
        End If
        Me.Invalidate(mThumbRect)
        Me.Select()
        mThumbImage = image
    End Sub

    Private Sub MyTrackBar_MouseWheel(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseWheel
        Dim Delta As Integer = e.Delta * SystemInformation.MouseWheelScrollLines / 120
        Me.Value += Delta
    End Sub

    Private Sub Class1_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseMove
        Select Case mOrientation
            Case enumOrientation.Horisontal
                If Me.Capture Then
                    mThumbState = VisualStyles.TrackBarThumbState.Pressed
                    mPosition = (e.X - XStart) / mStep + mMin

                    If mPosition <> Me.Value Then
                        Me.Value = mPosition
                    End If
                Else
                    If mThumbRect.Contains(e.X, e.Y) Then
                        If mThumbState <> VisualStyles.TrackBarThumbState.Hot Then
                            mThumbState = VisualStyles.TrackBarThumbState.Hot
                            Me.Invalidate(mThumbRect)
                        End If
                    Else
                        If mThumbState <> VisualStyles.TrackBarThumbState.Normal Then
                            mThumbState = VisualStyles.TrackBarThumbState.Normal
                            Me.Invalidate(mThumbRect)
                        End If
                    End If

                End If
            Case enumOrientation.Vertical
                If Me.Capture Then
                    mThumbState = VisualStyles.TrackBarThumbState.Pressed
                    mPosition = (e.Y - XStart) / mStep + mMin

                    If mPosition <> Me.Value Then
                        Me.Value = mPosition
                    End If
                Else
                    If mThumbRect.Contains(e.X, e.Y) Then
                        If mThumbState <> VisualStyles.TrackBarThumbState.Hot Then
                            mThumbState = VisualStyles.TrackBarThumbState.Hot
                            Me.Invalidate(mThumbRect)
                        End If
                    Else
                        If mThumbState <> VisualStyles.TrackBarThumbState.Normal Then
                            mThumbState = VisualStyles.TrackBarThumbState.Normal
                            Me.Invalidate(mThumbRect)
                        End If
                    End If

                End If

        End Select
    End Sub

    Protected Overrides Sub OnSizeChanged(ByVal e As System.EventArgs)
        Select Case mOrientation
            Case enumOrientation.Horisontal
                mThumbRect = New Rectangle(mVal * CInt(mStep), (Me.ClientRectangle.Height / 2) - (mThumbHeight / 2) + 2, mThumbWidth, mThumbHeight)

                mBodyRect = Me.ClientRectangle
                mBodyRect.Inflate(-mThumbWidth / 2, 0)

                Dim I1 As Integer = (Me.ClientRectangle.Width - mBodyRect.Width) / 2
                mTrackRect = New Rectangle(I1, Me.ClientRectangle.Height / 2, mBodyRect.Width, 5)

                mTicksRect = New Rectangle(I1, 10, mBodyRect.Width, 5)
                W = mTicksRect.Width - 2
                mStep = W / (Me.Maximum - Me.Minimum)


                XStart = mTicksRect.X
                XEnd = mTicksRect.Right
            Case enumOrientation.Vertical

                mThumbRect = New Rectangle((Me.ClientRectangle.Width / 2) - (mThumbWidth / 2) + 2, mVal * CInt(mStep), mThumbWidth, mThumbHeight)

                mBodyRect = Me.ClientRectangle
                mBodyRect.Inflate(-mThumbHeight / 2, 0)

                Dim I1 As Integer = (Me.ClientRectangle.Width - mBodyRect.Width) / 2 '(Me.ClientRectangle.Height - mBodyRect.Height) / 2
                mTrackRect = New Rectangle(Me.ClientRectangle.Width / 2, I1, 5, mBodyRect.Height - 20)
                mTicksRect = New Rectangle(10, I1, 5, mBodyRect.Height - 20)

                W = mTicksRect.Height - 2
                mStep = W / (Me.Maximum - Me.Minimum)


                XStart = mTicksRect.Y
                XEnd = mTicksRect.Top
        End Select

    End Sub

#End Region

#Region "Properties: Maximum, Minimum, Value"

    <DefaultValue(10), CategoryAttribute("Behavior")> _
Public Property Maximum() As Integer
        Get
            Return mMax
        End Get
        Set(ByVal value As Integer)
            mMax = value
            If mVal > mMax Then mVal = mMax
            mStep = W / (mMax - mMin)
            Me.Refresh()
        End Set
    End Property

    <DefaultValue(0), CategoryAttribute("Behavior")> _
    Public Property Minimum() As Integer
        Get
            Return mMin
        End Get
        Set(ByVal value As Integer)
            mMin = value
            If mVal < mMin Then mVal = mMin
            mStep = W / (mMax - mMin)
            Me.Refresh()
        End Set
    End Property

    <DefaultValue(0), CategoryAttribute("Behavior"), DescriptionAttribute("The position of the slider.")> _
   Public Property Value() As Integer
        Get
            Return mVal
        End Get
        Set(ByVal value As Integer)
            If value = mVal Then Exit Property

            If value > mMax Then
                mVal = mMax
            ElseIf value < mMin Then
                mVal = mMin
            Else
                mVal = value
            End If
            Me.Refresh()
            RaiseEvent ValueChanged(Me, Nothing)
        End Set
    End Property

#End Region

#Region "Properties: ThumbWidth, ThumbHeight, ThumbColor, ThumbMode, ThumbImage"

    <DefaultValue(20), Category("Thumb"), Description("Get or set thumb width.")> _
    Public Property ThumbWidth() As Integer
        Get
            Return mThumbWidth
        End Get
        Set(ByVal value As Integer)
            mThumbWidth = value
            OnSizeChanged(Nothing)
            Me.Refresh()
        End Set
    End Property

    <DefaultValue(20), Category("Thumb"), Description("Get or set thumb height.")> _
    Public Property ThumbHeight() As Integer
        Get
            Return mThumbHeight
        End Get
        Set(ByVal value As Integer)
            mThumbHeight = value
            OnSizeChanged(Nothing)
            Me.Refresh()
        End Set
    End Property

    <Category("Thumb"), Description("Get or set thumb color.")> _
Public Property ThumbColor() As Color
        Get
            Return mThumbColor
        End Get
        Set(ByVal value As Color)
            If MyBase.DesignMode Then
                If (value <> Color.Empty) Then
                    Dim descriptor As PropertyDescriptor = TypeDescriptor.GetProperties(Me).Item("UseVisualStyleBackColor")
                    If (Not descriptor Is Nothing) Then
                        descriptor.SetValue(Me, False)
                    End If
                End If
            End If
            mThumbColor = value
            mThumbBrush.Color = value
            Me.Refresh()
        End Set
    End Property

    <DefaultValue(GetType(enumThumbMode), "Custom"), Category("Thumb"), Description("Get or set thumb mode.")> _
Public Property ThumbMode() As enumThumbMode
        Get
            Return mThumbMode
        End Get
        Set(ByVal value As enumThumbMode)
            mThumbMode = value
            Me.Refresh()
        End Set
    End Property

    <DefaultValue(CStr(Nothing)), Localizable(True), Description("Get or set thumb image"), Category("Thumb")> _
Public Property ThumbImage() As Image
        Get
            Return mThumbImage
        End Get
        Set(ByVal value As Image)
            If (Not mThumbImage Is value) Then
                mThumbImage = value
                Me.Refresh()
            End If
        End Set
    End Property

    '==========================================================
    <DefaultValue(CStr(Nothing)), Localizable(True), Description("Get or set thumb image"), Category("Thumb")> _
Public Property ThumbImage2() As Image
        Get
            Return nThumbImage
        End Get
        Set(ByVal value As Image)
            If (Not nThumbImage Is value) Then
                nThumbImage = value
                Me.Refresh()
            End If
        End Set
    End Property

    '==========================================================
    <DefaultValue(CStr(Nothing)), Localizable(True), Description("Get or set thumb image"), Category("Thumb")> _
   Public Property ThumbImageEn() As Image
        Get
            Return EnThumbImage
        End Get
        Set(ByVal value As Image)
            If (Not EnThumbImage Is value) Then
                EnThumbImage = value
                Me.Refresh()
            End If
        End Set
    End Property

#End Region



#Region "Color"
    Private Sub MyTrackBar_BackColorChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.BackColorChanged

    End Sub
#End Region

#Region "Orientation"
    <DefaultValue(GetType(enumOrientation), "Custom"), Category("Thumb"), Description("Get or set thumb orientation.")> _
Public Property Orientation() As enumOrientation
        Get
            Return mOrientation
        End Get
        Set(ByVal value As enumOrientation)
            mOrientation = value

            '====================
            Select Case mOrientation
                Case enumOrientation.Horisontal
                    mThumbRect = New Rectangle(mVal * CInt(mStep), (Me.ClientRectangle.Height / 2) - (mThumbHeight / 2) + 2, mThumbWidth, mThumbHeight)

                    mBodyRect = Me.ClientRectangle
                    mBodyRect.Inflate(-mThumbWidth / 2, 0)

                    Dim I1 As Integer = (Me.ClientRectangle.Width - mBodyRect.Width) / 2
                    mTrackRect = New Rectangle(I1, Me.ClientRectangle.Height / 2, mBodyRect.Width, 5)

                    mTicksRect = New Rectangle(I1, 10, mBodyRect.Width, 5)
                    W = mTicksRect.Width - 2
                    mStep = W / (Me.Maximum - Me.Minimum)


                    XStart = mTicksRect.X
                    XEnd = mTicksRect.Right
                Case enumOrientation.Vertical

                    mThumbRect = New Rectangle((Me.ClientRectangle.Width / 2) - (mThumbWidth / 2) + 2, mVal * CInt(mStep), mThumbWidth, mThumbHeight)

                    mBodyRect = Me.ClientRectangle
                    mBodyRect.Inflate(-mThumbHeight / 2, 0)

                    Dim I1 As Integer = (Me.ClientRectangle.Width - mBodyRect.Width) / 2 '(Me.ClientRectangle.Height - mBodyRect.Height) / 2
                    mTrackRect = New Rectangle(Me.ClientRectangle.Width / 2, I1, 5, mBodyRect.Height - 20)
                    mTicksRect = New Rectangle(10, I1, 5, mBodyRect.Height - 20)

                    W = mTicksRect.Height - 2
                    mStep = W / (Me.Maximum - Me.Minimum)


                    XStart = mTicksRect.Y
                    XEnd = mTicksRect.Top
            End Select
            Me.Refresh()
        End Set
    End Property
#End Region

End Class




